PROGRAM Stop_WaitProtokoll;

{
Stop & Wait protokoll
Arvutivrgud
Teine kodulesanne
Kitty Dahl      971370
Erki  Suurjaak  970772
LAP41
03.05.1999
}

uses Crt;

const v = 200000000;
      WAck = 8;

var n : longint;                                                 {          }
    AndmeEdastusKiirus, TimeOut, TeenindusSagedus,               {          }
    LiiniPikkus, BitiVeaToenaosus, WData : real;                 { Sisendid }
    FailiNimi : string;                                          {          }
    f : text;                                                    {          }

    TootlusAeg, PaketteTimeOudis, PaketteVasakule,              { Vljundid }

    HetkTootlusAeg, WDataAeg, WAckiAeg,                          {          }
    FyysilisiPaketteTimeOudis, FyysilisiPaketteVasakule,         {          }
    PaketiVeaToenaosus, WAckiVeaToenaosus : real;                {  Olekud  }
    i : longint;                                                 {          }
    Vasakul, PakettOlnudTimeOudis, PakettOlnudVasakul : boolean; {          }


BEGIN
     writeln;
     write ('Sisesta saadetavate pakettide arv : ');
     readln (n);
     write ('Sisesta teenindussagedus (Hz) : ');
     readln (TeenindusSagedus);
     write ('Sisesta bitivea tenosus : ');
     readln (BitiVeaToenaosus);
     write ('Sisesta time-outi pikkus (sekundites) : ');
     readln (TimeOut);
     write ('Sisesta liini pikkus (meetrites) : ');
     readln (LiiniPikkus);
     write ('Sisesta andmeedastuskiirus (bitti sekundis) : ');
     readln (AndmeEdastusKiirus);
     write ('Sisesta paketi pikkus (bittides) : ');
     readln (WData);
     write ('Sisesta vljundfaili nimi (thi string = ekraan) : ');
     readln (FailiNimi);

     Randomize;
     WDataAeg := WData / AndmeEdastusKiirus + LiiniPikkus / v;
     WAckiAeg := WAck / AndmeEdastusKiirus + LiiniPikkus / v;
     PaketiVeaToenaosus := 1 - exp (WData * ln ((1 - BitiVeaToenaosus)));
     WAckiVeaToenaosus := 1 - exp (WAck * ln ((1 - BitiVeaToenaosus)));
     Assign (f, Failinimi);
     Rewrite (f);

     TootlusAeg := 0;
     PaketteVasakule := 0;
     PaketteTimeOudis := 0;
     FyysilisiPaketteVasakule := 0;
     FyysilisiPaketteTimeOudis := 0;

     writeln;
     write ('Simuleerin..');
     for i := 1 to n do
      begin
       (* Kui andmeedastus snagi vimatu, siis vlja *)
       if (FyysilisiPaketteVasakule > 10*n) then
        begin
        TootlusAeg := 0;
        FyysilisiPaketteVasakule := 0;
        PaketteVasakule := 0;
        PaketteTimeOudis := 0;
        Break;
        end;
       (* /Kui andmeedastus snagi vimatu, siis vlja *)


      Vasakul := False;
      PakettOlnudTimeOudis := False;
      PakettOlnudVasakul := False;

      (* Kontroll, ega pakett ei ole riknenud *)
      if Random < PaketiVeaToenaosus then Vasakul := True;
      (* /Kontroll, ega pakett ei ole riknenud *)

       repeat

       (* Kui andmeedastus snagi vimatu, siis vlja *)
       if (FyysilisiPaketteVasakule > 10*n) then Break;
       (* /Kui andmeedastus snagi vimatu, siis vlja *)


       If Vasakul Then

        (* Saadetakse uus pakett ja kontrollitakse selle korrasolekut *)
        begin
        FyysilisiPaketteVasakule := FyysilisiPaketteVasakule + 1;
        if not PakettOlnudVasakul then
         begin
         PaketteVasakule := PaketteVasakule + 1;
         PakettOlnudVasakul := True;
         end;
        if Random < PaketiVeaToenaosus then Vasakul := True else Vasakul := False;
        end;
        (* /Saadetakse uus pakett ja kontrollitakse selle korrasolekut *)

       If not Vasakul then
        begin
        HetkTootlusAeg := - ln (Random) / TeenindusSagedus;
        If HetkTootlusAeg + WDataAeg + WAckiAeg < TimeOut Then
            begin

            (* Kontroll, ega kviteering ei riknenud *)
            If Random < WAckiVeaToenaosus then Vasakul := True
            (* /Kontroll, ega kviteering ei riknenud *)

             (* Asi on korras ja pakett on probleemideta edastet *)
             else TootlusAeg := TootlusAeg + HetkTootlusAeg;
             (* /Asi on korras ja pakett on probleemideta edastet *)

            end

         else

         (* Kviteering ei judnud korralikult kohale *)
          begin
          Vasakul := True;
          FyysilisiPaketteTimeOudis := FyysilisiPaketteTimeOudis + 1;
          if not PakettOlnudTimeOudis then
           begin
           PaketteTimeOudis := PaketteTimeOudis + 1;
           PakettOlnudTimeOudis := True;
           end;

          (* Kviteering prkas uuestisaadetud paketiga kokku *)
          if (HetkTootlusAeg + WDataAeg + WAckiAeg >= TimeOut) and
             (HetkTootlusAeg + WAckiAeg <= TimeOut)
              then
               begin
               FyysilisiPaketteTimeOudis := FyysilisiPaketteTimeOudis + 1;
               FyysilisiPaketteVasakule := FyysilisiPaketteVasakule + 1;
               end;
          (* /Kviteering prkas uuestisaadetud paketiga kokku *)

          end;
         (* /Kviteering ei judnud korralikult kohale *)

        end;
       until not Vasakul;
      end;
      if TootlusAeg > 0 then TootlusAeg := TootlusAeg + n*(WDataAeg + WAckiAeg)
               + FyysilisiPaketteVasakule*TimeOut;
      ClrScr;
      writeln (f, 'SISENDID');
      writeln (f, 'Pakettide arv      : ', n);
      writeln (f, 'Teenindussagedus   : ', TeenindusSagedus:0:0, ' Hz');
      writeln (f, 'Bitivea tenosus  : ', BitiVeaToenaosus:0:5);
      writeln (f, 'Timeouti pikkus    : ', TimeOut:0:4, ' s');
      writeln (f, 'Liini pikkus       : ', LiiniPikkus:0:0, ' m');
      writeln (f, 'Andmeedastuskiirus : ', AndmeedastusKiirus:0:0, ' bit/s');
      writeln (f, 'Paketi pikkus      : ', WData:0:0, ' bitti');
      writeln(f);
      writeln (f, 'VLJUNDID');
      writeln (f, 'Edastusaeg                    : ', TootlusAeg:0:5, ' sekundit.');
      writeln (f, 'Pakette lks vasakule         : ', (PaketteVasakule - PaketteTimeOudis):0:0,
       ' tkki ehk ', (PaketteVasakule - PaketteTimeOudis)/n*100:0:6, '%');
      writeln (f, 'Pakette oli timeoudis         : ', PaketteTimeOudis:0:0, ' tkki ehk ', PaketteTimeOudis/n*100:0:6, '%');
      write (f, 'Efektiivne lbilaskevime     : ');
      if TootlusAeg > 0 then write (f, n * WData / tootlusaeg:0:0) else write (f, '0');
      writeln (f, ' bitti sekundis');
      write (f, 'Kanali kasutamise efektiivsus : ');
      if TootlusAeg > 0 then write (f, (n * WData / tootlusaeg / AndmeEdastusKiirus * 100):2:2)
         else write (f, '0');
      writeln (f, '%');
      Close (f);
      readkey;
END.
